/*
 * Copyright (c) 2001 Network Appliance, Inc.
 * All rights reserved.
 */

#ifndef _GBUF_H_
#define _GBUF_H_

/* growable buffer */

typedef struct gbuf {
  int			blk_size;		/* size of blocks allocated */
  int			length;			/* current length of gbuf   */
  char 			*data;			/* actual buffer	    */
} gbuf_t;

extern struct gbuf *gbuf_alloc(int blk_size);
extern int gbuf_concat(struct gbuf *buf, const char *str, int len);
extern void gbuf_zero(struct gbuf *buf);
extern void gbuf_free(struct gbuf *buf);

#endif // _GBUF_H_
